static char rcsid[] = "@(#)$Id: okay_addr.c,v 2.0 2007-08-25 11:51:45 hurtta Exp $";

/******************************************************************************
 *  The Elm (ME+) Mail System  -  $Revision: 2.0 $   $State: Exp $
 *
 *  Reimplemented by: Kari Hurtta <hurtta+elm@posti.FMI.FI> 
 *                            (was hurtta+elm@ozone.FMI.FI)
 *                or  Kari Hurtta <elm@elmme-mailer.org>
 ******************************************************************************
 *  This code is reimplemented. Original code on Elm 2.4 lib/okay_addr.c 
 *  was following copyright:
 *
 *  The Elm Mail System 
 *
 *			Copyright (c) 1988-1992 USENET Community Trust
 *			Copyright (c) 1986,1987 Dave Taylor
 *****************************************************************************/

#include "def_addr.h"


DEBUG_VAR(Debug,__FILE__,"addr");


int okay_address_l(address, return_address_list)
     const struct address  *address;
     const struct addr_list * return_address_list;
{  
    const char          * addr     = address_get_ascii_addr(address);
    const struct string * fullname = address_get_phrase(address);
    const struct string * comment  = address_get_comment(address);
    
    /** This routine checks to ensure that the address we just got
	from the "To:" or "Cc:" line isn't us AND isn't the person	
	who sent the message.  Returns true iff neither is the case **/
    
    
    if (!addr) {
	DPRINT(Debug,25,(&Debug,
			 "okay_address_l=0\n"));

	return 0;
    }

    if (return_address_list) {

	int idx, addr_item_count = addr_list_item_count(return_address_list);

	for (idx = 0; idx < addr_item_count; idx++) {
	    int group = -1;
	    const struct address * return_address = 
		addr_list_get_item(return_address_list,idx,&group);
	    
	    const char          * return_addr     = address_get_ascii_addr(return_address);
	    const struct string * return_fullname = address_get_phrase(return_address);
	    const struct string * return_comment  = address_get_comment(return_address);
	    
	    if (!return_addr)
		continue;
	
	    if (0 == strcmp(return_addr, addr)) {
		DPRINT(Debug,25,(&Debug,
				 "okay_address_l=0:\n"));
		DPRINT(Debug,25,(&Debug,
				 "     address{addr=%s,fullname=%S} same as return_address {addr=%s,fullname=%S}\n",
				 addr, fullname,
				 return_addr, return_fullname));
		return 0;
	    }
	}
    }

    if (addr_is_user(addr)) {
	DPRINT(Debug,25,(&Debug,
			 "okay_address_l=0:\n"));
	DPRINT(Debug,25,(&Debug,
			 "     address{addr=%s,fullname=%S} is user's address\n",
			 addr, fullname));	
	return 0;
    }
    
    DPRINT(Debug,25,(&Debug,
		     "okay_address_l=1:\n"));
    DPRINT(Debug,25,(&Debug,
		     "     address{addr=%s,fullname=%S} is not our address.\n",
		     addr, fullname)); 
    return 1;
}


/*
 * Local Variables:
 *  mode:c
 *  c-basic-offset:4
 *  buffer-file-coding-system: iso-8859-1
 * End:
 */
